//-----------------------------------------------------------------------------
// Title      : bsp_ub049_mk3_counter2
//-----------------------------------------------------------------------------
// Funktion   : Counter Test2
// Schaltung  : myAVR MK3
//-----------------------------------------------------------------------------
// Prozessor  : ATMega2560
// Takt       : 16 MHz
// Sprache    : C
// Date       : 16.06.2012
// Version    : 1.0
// Autor      : UB
//-----------------------------------------------------------------------------
#define F_CPU 16000000
#include <avr/io.h>
#include <ub_mk3_2560/MK3_2560_COUNTER.h>
#include <ub_mk3_2560/MK3_2560_LCD.h>


//-----------------------------------------------------------------------------
// Hinweis :
// - Quick-Jumper Port-C+A muss gesetzt sein
// - benutzt Counter Funktion um die Dauer
//   einer Berechnung zu messen
// 
//-----------------------------------------------------------------------------
int main (void)
{
	float a=0.0;
	float b=123.4;
	float c=5678.9;
	
	unsigned int n=0;

	MK3_INIT_COUNTER();				// init vom Counter
	MK3_INIT_LCD();                 // Init vom Display

	MK3_LCD_CLEAR();
	MK3_LCD_LIGHT(true);

	MK3_LCD_STRING_AT(0,0,"Counter-Test 2");

	MK3_LCD_STRING_AT(0,16,"Messung start");


	// Counter vorbereiten im Mode : Mikrosekunden
	// und Stop-Bedingung : Stop-Funktion
	MK3_COUNTER_SET(TYP_US_10000,START_FKT,STOP_FKT);
	
	// hier wird der Counter gestartet
	MK3_COUNTER_START();
	
	// hier wird eine Software Berechnung gemacht
	// [b=123.4 , c=5678.9]
	// ohne Berechnung  : Dauer =   2 us
	// Berechnung a=b+c : Dauer =  59 us
	// Berechnung a=b-c : Dauer =  62 us
	// Berechnung a=b*c : Dauer = 133 us
	// Berechnung a=b/c : Dauer =  82 us
	
	a=b+c;
	
	// hier wird der Counter gestoppt
	MK3_COUNTER_STOP();
	
	// Anzeige vom Ergebnis
	MK3_LCD_STRING_AT(0,24,"Messung stop");

    // Zeit auslesen
	n=MK3_COUNTER_READ_TIME();
	MK3_LCD_UINT_AT(0,40,n);
	MK3_LCD_STRING_AT(35,40,"us");

	while (true)
	{

		// endlosloop

	}
	return 0;
}
//-----------------------------------------------------------------------------
